;***************************************************************
function mag_frequency_response, Csr, freq_cal
; This calibration function is used to make a correction for the frequency response and transfer function
; Cfr = Csr - Fi
; Cfr is the modified count readings after Frequency Response and Transfer function had applied, in the form of CXfr, CYfr and CZfr
;

; Return values initialization
CXfr = 0
CYfr = 0
CZfr = 0
    CXfr = Csr(0) - freq_cal(0)
    CYfr = Csr(1) - freq_cal(1)
    CZfr = Csr(2) - freq_cal(2)
Cfr = [CXfr, CYfr, CZfr]

return, Cfr

end; end of function

