;APID 208h, 209h (520d, 521d)
function mag_load_struct_20x, packet
if not !quiet then print,"In function mag_load_struct_20x"
apid = parse_stereo_pkt(packet, /APID )
; MAG structure for APID 208h, 209h (MAG Telemetry Packet)
MAG_DATA = {MAG_STRUCT_20x, $
;;          XX:      BYTARR(7), $
;;;          XX: BYTARR(6), $
;;;          CLOCK2:   0B, $
;;;          CLOCK1:   0B, $
;;;          CLOCK4:   0B, $
;;;          CLOCK3:   0B, $
;;;          SUBSEC_LSB: 0B, $
          SUBSEC_MSB: 0B, $
          MAGTLMAVG:0B, $
          FIRSTSAMPLE:0B, $
          IMAGHKP:  0U, $
          SPARE:    0B, $
          MAGSENSORMODE:0B, $
;          MAG_XYZ_COUNT: uintarr(42*3)}
          MAGX_01:  0, $
          MAGY_01:  0, $
          MAGZ_01:  0, $
          MAGX_02:  0, $
          MAGY_02:  0, $
          MAGZ_02:  0, $
          MAGX_03:  0, $
          MAGY_03:  0, $
          MAGZ_03:  0, $
          MAGX_04:  0, $
          MAGY_04:  0, $
          MAGZ_04:  0, $
          MAGX_05:  0, $
          MAGY_05:  0, $
          MAGZ_05:  0, $
          MAGX_06:  0, $
          MAGY_06:  0, $
          MAGZ_06:  0, $
          MAGX_07:  0, $
          MAGY_07:  0, $
          MAGZ_07:  0, $
          MAGX_08:  0, $
          MAGY_08:  0, $
          MAGZ_08:  0, $
          MAGX_09:  0, $
          MAGY_09:  0, $
          MAGZ_09:  0, $
          MAGX_10:  0, $
          MAGY_10:  0, $
          MAGZ_10:  0, $
          MAGX_11:  0, $
          MAGY_11:  0, $
          MAGZ_11:  0, $
          MAGX_12:  0, $
          MAGY_12:  0, $
          MAGZ_12:  0, $
          MAGX_13:  0, $
          MAGY_13:  0, $
          MAGZ_13:  0, $
          MAGX_14:  0, $
          MAGY_14:  0, $
          MAGZ_14:  0, $
          MAGX_15:  0, $
          MAGY_15:  0, $
          MAGZ_15:  0, $
          MAGX_16:  0, $
          MAGY_16:  0, $
          MAGZ_16:  0, $
          MAGX_17:  0, $
          MAGY_17:  0, $
          MAGZ_17:  0, $
          MAGX_18:  0, $
          MAGY_18:  0, $
          MAGZ_18:  0, $
          MAGX_19:  0, $
          MAGY_19:  0, $
          MAGZ_19:  0, $
          MAGX_20:  0, $
          MAGY_20:  0, $
          MAGZ_20:  0, $
          MAGX_21:  0, $
          MAGY_21:  0, $
          MAGZ_21:  0, $
          MAGX_22:  0, $
          MAGY_22:  0, $
          MAGZ_22:  0, $
          MAGX_23:  0, $
          MAGY_23:  0, $
          MAGZ_23:  0, $
          MAGX_24:  0, $
          MAGY_24:  0, $
          MAGZ_24:  0, $
          MAGX_25:  0, $
          MAGY_25:  0, $
          MAGZ_25:  0, $
          MAGX_26:  0, $
          MAGY_26:  0, $
          MAGZ_26:  0, $
          MAGX_27:  0, $
          MAGY_27:  0, $
          MAGZ_27:  0, $
          MAGX_28:  0, $
          MAGY_28:  0, $
          MAGZ_28:  0, $
          MAGX_29:  0, $
          MAGY_29:  0, $
          MAGZ_29:  0, $
          MAGX_30:  0, $
          MAGY_30:  0, $
          MAGZ_30:  0, $
          MAGX_31:  0, $
          MAGY_31:  0, $
          MAGZ_31:  0, $
          MAGX_32:  0, $
          MAGY_32:  0, $
          MAGZ_32:  0, $
          MAGX_33:  0, $
          MAGY_33:  0, $
          MAGZ_33:  0, $
          MAGX_34:  0, $
          MAGY_34:  0, $
          MAGZ_34:  0, $
          MAGX_35:  0, $
          MAGY_35:  0, $
          MAGZ_35:  0, $
          MAGX_36:  0, $
          MAGY_36:  0, $
          MAGZ_36:  0, $
          MAGX_37:  0, $
          MAGY_37:  0, $
          MAGZ_37:  0, $
          MAGX_38:  0, $
          MAGY_38:  0, $
          MAGZ_38:  0, $
          MAGX_39:  0, $
          MAGY_39:  0, $
          MAGZ_39:  0, $
          MAGX_40:  0, $
          MAGY_40:  0, $
          MAGZ_40:  0, $
          MAGX_41:  0, $
          MAGY_41:  0, $
          MAGZ_41:  0, $
          MAGX_42:  0, $
          MAGY_42:  0, $
          MAGZ_42:  0}
 
 
; MAG PTP's dat is 261 bytes long
; read packet (MAG PTP) from 0th bytes to 260th bytes
;rawimpactb = packet.dat[0:7+252+1+1-1]
rawimpactb = packet.dat[0:260]
if not !quiet then print,rawimpactb
;********************************************************************
;*  William Thompson, use LOAD_STRUCT instead of temporary file.
;*
;*openw, tmpu, '/tmp/rawimpact.dat', /get_lun, error = error_flag
;*writeu, tmpu, rawimpactb
;*free_lun, tmpu
;*
;*;read back into structure
;*openr, tmpu, '/tmp/rawimpact.dat', /get_lun, error = error_flag
;*   IF (error_flag ne 0) then BEGIN
;*   printf, -2, !err_string
;*exit, /NO_CONFIRM, STATUS=-1
;*ENDIF
;*; read packet into MAG_DATA
;*readu, tmpu, MAG_DATA
;*free_lun, tmpu
;********************************************************************

;Use the /LITTLE keyword if MAG_DATA is little-endian.
load_struct, rawimpactb, MAG_DATA[0], MAG_DATA, /LITTLE
if not !quiet then help,/structure,MAG_DATA

;; debug - Use Dave Curtis's test data
;;MAG_DATA.MAGX_01 = '0772'X
;;MAG_DATA.MAGY_01 = '1A92'X
;;MAG_DATA.MAGZ_01 = 'A97F'X
;;MAG_DATA.IMAGHKP = '8581'X

;; debug
;;print, "Before swap and offset correction"
;;print, MAG_DATA

; Swap bype correction
MAG_DATA = swap_endian (MAG_DATA)
; Offset 8000h correction
;mag_sets = 42
;SETS = 0
;repeat begin
;MAG_DATA.MAG_XYZ_COUNT (SETS * 3) = MAG_DATA.MAG_XYZ_COUNT (SETS * 3) - '8000'X
;MAG_DATA.MAG_XYZ_COUNT (SETS * 3 + 1) = MAG_DATA.MAG_XYZ_COUNT (SETS * 3 + 1) - '8000'X
;MAG_DATA.MAG_XYZ_COUNT (SETS * 3 + 2) = MAG_DATA.MAG_XYZ_COUNT (SETS * 3 + 2) - '8000'X
;SETS = SETS + 1
;endrep until SETS gt (mag_sets - 1)
MAG_DATA.MAGX_01 = MAG_DATA.MAGX_01 - '8000'X
MAG_DATA.MAGY_01 = MAG_DATA.MAGY_01 - '8000'X
MAG_DATA.MAGZ_01 = MAG_DATA.MAGZ_01 - '8000'X
MAG_DATA.MAGX_02 = MAG_DATA.MAGX_02 - '8000'X
MAG_DATA.MAGY_02 = MAG_DATA.MAGY_02 - '8000'X
MAG_DATA.MAGZ_02 = MAG_DATA.MAGZ_02 - '8000'X
MAG_DATA.MAGX_03 = MAG_DATA.MAGX_03 - '8000'X
MAG_DATA.MAGY_03 = MAG_DATA.MAGY_03 - '8000'X
MAG_DATA.MAGZ_03 = MAG_DATA.MAGZ_03 - '8000'X
MAG_DATA.MAGX_04 = MAG_DATA.MAGX_04 - '8000'X
MAG_DATA.MAGY_04 = MAG_DATA.MAGY_04 - '8000'X
MAG_DATA.MAGZ_04 = MAG_DATA.MAGZ_04 - '8000'X
MAG_DATA.MAGX_05 = MAG_DATA.MAGX_05 - '8000'X
MAG_DATA.MAGY_05 = MAG_DATA.MAGY_05 - '8000'X
MAG_DATA.MAGZ_05 = MAG_DATA.MAGZ_05 - '8000'X
MAG_DATA.MAGX_06 = MAG_DATA.MAGX_06 - '8000'X
MAG_DATA.MAGY_06 = MAG_DATA.MAGY_06 - '8000'X
MAG_DATA.MAGZ_06 = MAG_DATA.MAGZ_06 - '8000'X
MAG_DATA.MAGX_07 = MAG_DATA.MAGX_07 - '8000'X
MAG_DATA.MAGY_07 = MAG_DATA.MAGY_07 - '8000'X
MAG_DATA.MAGZ_07 = MAG_DATA.MAGZ_07 - '8000'X
MAG_DATA.MAGX_08 = MAG_DATA.MAGX_08 - '8000'X
MAG_DATA.MAGY_08 = MAG_DATA.MAGY_08 - '8000'X
MAG_DATA.MAGZ_08 = MAG_DATA.MAGZ_08 - '8000'X
MAG_DATA.MAGX_09 = MAG_DATA.MAGX_09 - '8000'X
MAG_DATA.MAGY_09 = MAG_DATA.MAGY_09 - '8000'X
MAG_DATA.MAGZ_09 = MAG_DATA.MAGZ_09 - '8000'X
MAG_DATA.MAGX_10 = MAG_DATA.MAGX_10 - '8000'X
MAG_DATA.MAGY_10 = MAG_DATA.MAGY_10 - '8000'X
MAG_DATA.MAGZ_10 = MAG_DATA.MAGZ_10 - '8000'X
MAG_DATA.MAGX_11 = MAG_DATA.MAGX_11 - '8000'X
MAG_DATA.MAGY_11 = MAG_DATA.MAGY_11 - '8000'X
MAG_DATA.MAGZ_11 = MAG_DATA.MAGZ_11 - '8000'X
MAG_DATA.MAGX_12 = MAG_DATA.MAGX_12 - '8000'X
MAG_DATA.MAGY_12 = MAG_DATA.MAGY_12 - '8000'X
MAG_DATA.MAGZ_12 = MAG_DATA.MAGZ_12 - '8000'X
MAG_DATA.MAGX_13 = MAG_DATA.MAGX_13 - '8000'X
MAG_DATA.MAGY_13 = MAG_DATA.MAGY_13 - '8000'X
MAG_DATA.MAGZ_13 = MAG_DATA.MAGZ_13 - '8000'X
MAG_DATA.MAGX_14 = MAG_DATA.MAGX_14 - '8000'X
MAG_DATA.MAGY_14 = MAG_DATA.MAGY_14 - '8000'X
MAG_DATA.MAGZ_14 = MAG_DATA.MAGZ_14 - '8000'X
MAG_DATA.MAGX_15 = MAG_DATA.MAGX_15 - '8000'X
MAG_DATA.MAGY_15 = MAG_DATA.MAGY_15 - '8000'X
MAG_DATA.MAGZ_15 = MAG_DATA.MAGZ_15 - '8000'X
MAG_DATA.MAGX_16 = MAG_DATA.MAGX_16 - '8000'X
MAG_DATA.MAGY_16 = MAG_DATA.MAGY_16 - '8000'X
MAG_DATA.MAGZ_16 = MAG_DATA.MAGZ_16 - '8000'X
MAG_DATA.MAGX_17 = MAG_DATA.MAGX_17 - '8000'X
MAG_DATA.MAGY_17 = MAG_DATA.MAGY_17 - '8000'X
MAG_DATA.MAGZ_17 = MAG_DATA.MAGZ_17 - '8000'X
MAG_DATA.MAGX_18 = MAG_DATA.MAGX_18 - '8000'X
MAG_DATA.MAGY_18 = MAG_DATA.MAGY_18 - '8000'X
MAG_DATA.MAGZ_18 = MAG_DATA.MAGZ_18 - '8000'X
MAG_DATA.MAGX_19 = MAG_DATA.MAGX_19 - '8000'X
MAG_DATA.MAGY_19 = MAG_DATA.MAGY_19 - '8000'X
MAG_DATA.MAGZ_19 = MAG_DATA.MAGZ_19 - '8000'X
MAG_DATA.MAGX_20 = MAG_DATA.MAGX_20 - '8000'X
MAG_DATA.MAGY_20 = MAG_DATA.MAGY_20 - '8000'X
MAG_DATA.MAGZ_20 = MAG_DATA.MAGZ_20 - '8000'X
MAG_DATA.MAGX_21 = MAG_DATA.MAGX_21 - '8000'X
MAG_DATA.MAGY_21 = MAG_DATA.MAGY_21 - '8000'X
MAG_DATA.MAGZ_21 = MAG_DATA.MAGZ_21 - '8000'X
MAG_DATA.MAGX_22 = MAG_DATA.MAGX_22 - '8000'X
MAG_DATA.MAGY_22 = MAG_DATA.MAGY_22 - '8000'X
MAG_DATA.MAGZ_22 = MAG_DATA.MAGZ_22 - '8000'X
MAG_DATA.MAGX_23 = MAG_DATA.MAGX_23 - '8000'X
MAG_DATA.MAGY_23 = MAG_DATA.MAGY_23 - '8000'X
MAG_DATA.MAGZ_23 = MAG_DATA.MAGZ_23 - '8000'X
MAG_DATA.MAGX_24 = MAG_DATA.MAGX_24 - '8000'X
MAG_DATA.MAGY_24 = MAG_DATA.MAGY_24 - '8000'X
MAG_DATA.MAGZ_24 = MAG_DATA.MAGZ_24 - '8000'X
MAG_DATA.MAGX_25 = MAG_DATA.MAGX_25 - '8000'X
MAG_DATA.MAGY_25 = MAG_DATA.MAGY_25 - '8000'X
MAG_DATA.MAGZ_25 = MAG_DATA.MAGZ_25 - '8000'X
MAG_DATA.MAGX_26 = MAG_DATA.MAGX_26 - '8000'X
MAG_DATA.MAGY_26 = MAG_DATA.MAGY_26 - '8000'X
MAG_DATA.MAGZ_26 = MAG_DATA.MAGZ_26 - '8000'X
MAG_DATA.MAGX_27 = MAG_DATA.MAGX_27 - '8000'X
MAG_DATA.MAGY_27 = MAG_DATA.MAGY_27 - '8000'X
MAG_DATA.MAGZ_27 = MAG_DATA.MAGZ_27 - '8000'X
MAG_DATA.MAGX_28 = MAG_DATA.MAGX_28 - '8000'X
MAG_DATA.MAGY_28 = MAG_DATA.MAGY_28 - '8000'X
MAG_DATA.MAGZ_28 = MAG_DATA.MAGZ_28 - '8000'X
MAG_DATA.MAGX_29 = MAG_DATA.MAGX_29 - '8000'X
MAG_DATA.MAGY_29 = MAG_DATA.MAGY_29 - '8000'X
MAG_DATA.MAGZ_29 = MAG_DATA.MAGZ_29 - '8000'X
MAG_DATA.MAGX_30 = MAG_DATA.MAGX_30 - '8000'X
MAG_DATA.MAGY_30 = MAG_DATA.MAGY_30 - '8000'X
MAG_DATA.MAGZ_30 = MAG_DATA.MAGZ_30 - '8000'X
MAG_DATA.MAGX_31 = MAG_DATA.MAGX_31 - '8000'X
MAG_DATA.MAGY_31 = MAG_DATA.MAGY_31 - '8000'X
MAG_DATA.MAGZ_31 = MAG_DATA.MAGZ_31 - '8000'X
MAG_DATA.MAGX_32 = MAG_DATA.MAGX_32 - '8000'X
MAG_DATA.MAGY_32 = MAG_DATA.MAGY_32 - '8000'X
MAG_DATA.MAGZ_32 = MAG_DATA.MAGZ_32 - '8000'X
MAG_DATA.MAGX_33 = MAG_DATA.MAGX_33 - '8000'X
MAG_DATA.MAGY_33 = MAG_DATA.MAGY_33 - '8000'X
MAG_DATA.MAGZ_33 = MAG_DATA.MAGZ_33 - '8000'X
MAG_DATA.MAGX_34 = MAG_DATA.MAGX_34 - '8000'X
MAG_DATA.MAGY_34 = MAG_DATA.MAGY_34 - '8000'X
MAG_DATA.MAGZ_34 = MAG_DATA.MAGZ_34 - '8000'X
MAG_DATA.MAGX_35 = MAG_DATA.MAGX_35 - '8000'X
MAG_DATA.MAGY_35 = MAG_DATA.MAGY_35 - '8000'X
MAG_DATA.MAGZ_35 = MAG_DATA.MAGZ_35 - '8000'X
MAG_DATA.MAGX_36 = MAG_DATA.MAGX_36 - '8000'X
MAG_DATA.MAGY_36 = MAG_DATA.MAGY_36 - '8000'X
MAG_DATA.MAGZ_36 = MAG_DATA.MAGZ_36 - '8000'X
MAG_DATA.MAGX_37 = MAG_DATA.MAGX_37 - '8000'X
MAG_DATA.MAGY_37 = MAG_DATA.MAGY_37 - '8000'X
MAG_DATA.MAGZ_37 = MAG_DATA.MAGZ_37 - '8000'X
MAG_DATA.MAGX_38 = MAG_DATA.MAGX_38 - '8000'X
MAG_DATA.MAGY_38 = MAG_DATA.MAGY_38 - '8000'X
MAG_DATA.MAGZ_38 = MAG_DATA.MAGZ_38 - '8000'X
MAG_DATA.MAGX_39 = MAG_DATA.MAGX_39 - '8000'X
MAG_DATA.MAGY_39 = MAG_DATA.MAGY_39 - '8000'X
MAG_DATA.MAGZ_39 = MAG_DATA.MAGZ_39 - '8000'X
MAG_DATA.MAGX_40 = MAG_DATA.MAGX_40 - '8000'X
MAG_DATA.MAGY_40 = MAG_DATA.MAGY_40 - '8000'X
MAG_DATA.MAGZ_40 = MAG_DATA.MAGZ_40 - '8000'X
MAG_DATA.MAGX_41 = MAG_DATA.MAGX_41 - '8000'X
MAG_DATA.MAGY_41 = MAG_DATA.MAGY_41 - '8000'X
MAG_DATA.MAGZ_41 = MAG_DATA.MAGZ_41 - '8000'X
MAG_DATA.MAGX_42 = MAG_DATA.MAGX_42 - '8000'X
MAG_DATA.MAGY_42 = MAG_DATA.MAGY_42 - '8000'X
MAG_DATA.MAGZ_42 = MAG_DATA.MAGZ_42 - '8000'X


;; debug
;;print, "After swap and offset correction"
;;print, MAG_DATA

; Test - Set bit 11, 12, 15 to 1
; Example for setting status bits
;MAG_DATA.IMAGHKP='9800'X
SPARE_TIEDHIGH = 0
INTERFACE_PARITY = 0
INTERFACE_TIMEOUT = 0
ADC_CAL = 0
IN_FLIGHT_CAL = 0
RANGE_SENSITIVITY = 0
IF MAG_DATA.IMAGHKP eq 0 then begin
; 1 = command parity error
;   INTERFACE_PARITY_OK = 1                      ;bit 11
; 1 = interface timout
;   INTERFACE_TIMEOUT_OK = 1                     ;bit 12
; 0 = off, 1 = on
;   ADC_CAL_OFF = 1                              ;bit 13

; 0 = off, 1 = on
;   IN_FLIGHT_CAL_OFF = 1                        ;bit 14
; 0 = high, 1 = low
;   RANGE_LOW_FIELDS_HIGH_SENSITIVITY = 1        ;bit 15
; Verify
if not !quiet then begin
    print,"Verify..."
    help,/structure,MAG_DATA
    print, "IMAGHKP Bits are all zeros", MAG_DATA.IMAGHKP
endif
END ELSE BEGIN IF ISHFT(MAG_DATA.IMAGHKP AND '0100'X, -8) then begin
   SPARE_TIEDHIGH = 1
if not !quiet then print, "bit 8 - SPARE_OK is true"
END
IF ISHFT(MAG_DATA.IMAGHKP AND '0800'X, -11) then begin
   INTERFACE_PARITY = 1
if not !quiet then print, "bit 11 - INTERFACE_PARITY is true"
END
IF ISHFT(MAG_DATA.IMAGHKP AND '1000'X, -12) then begin
   INTERFACE_TIMEOUT = 1
if not !quiet then print, "bit 12 - INTERFACE_TIMEOUT is true"
END
IF ISHFT(MAG_DATA.IMAGHKP AND '2000'X, -13) then begin
   ADC_CAL = 1
if not !quiet then print, "bit 13 - ADC_CAL is true"
END
IF ISHFT(MAG_DATA.IMAGHKP AND '4000'X, -14) then begin
   IN_FLIGHT_CAL = 1
if not !quiet then print, "bit 14 - IN_FLIGHT_CAL is true"
END
IF ISHFT(MAG_DATA.IMAGHKP AND '8000'X, -15) then begin
   RANGE_SENSITIVITY = 1
if not !quiet then print, "bit 15 - RANGE_SENSITIVITY is true" ;high (0) = 1/64 nt, low (1) = 2nt
END
ENDELSE

;IF RANGE_SENSITIVITY eq 0 then print, "Range is low",RANGE_SENSITIVITY ELSE print, "Range is high", RANGE_SENSITIVITY

; Verify
if not !quiet then begin
    print,"Verify..."
    print,"MAG_DATA before adjustments"
    print,MAG_DATA
    help,/structure,MAG_DATA
endif

RETURN, MAG_DATA
end;
